import Joi from "joi";

import { UndefinedOr } from "../../../../utilities";

import { RuleValidator } from "../RuleValidator";
import { DomainError, handleDomainError } from "../errors";
import { Result } from "./Result";
import {
  IStringValueObjectOptions,
  StringValueObject,
} from "./StringValueObject";

export class Email extends StringValueObject {
  protected static validate(
    value: UndefinedOr<string>,
    options: IStringValueObjectOptions
  ) {
    const rule = Joi.string()
      .allow(null)
      .allow("")
      .default("")
      .email({
        tlds: { allow: false },
      })
      .label(options.label ? options.label : "value");

    return RuleValidator.validate<string>(rule, value);
  }

  public static create(
    value: UndefinedOr<string>,
    options: IStringValueObjectOptions = {}
  ) {
    const _options = {
      label: "email",
      ...options,
    };

    const validationResult = Email.validate(value, _options);

    if (validationResult.isFailure) {
      return Result.fail(
        handleDomainError(
          DomainError.INVALID_INPUT_DATA,
          validationResult.error.message,
          _options
        )
      );
    }
    return Result.ok(new Email(validationResult.object));
  }
}

export class Email_ValidationError extends Joi.ValidationError {}
